Index: /orxonox/branches/updater/src/gui/orxonox_gui_banner.cc
===================================================================
--- /orxonox/branches/updater/src/gui/orxonox_gui_banner.cc	(revision 3286)
+++ /orxonox/branches/updater/src/gui/orxonox_gui_banner.cc	(revision 3287)
@@ -32,6 +32,6 @@
 {
   // Banner Itself //
-  bannerEventBox = new EventBox ("BannerEventBox");
-  bannerImage = new Image ("banner.xpm");
+  bannerEventBox = new EventBox("BannerEventBox");
+  bannerImage = new Image("banner.xpm");
   bannerEventBox->fill(bannerImage);
 
Index: /orxonox/branches/updater/src/gui/orxonox_gui_flags.cc
===================================================================
--- /orxonox/branches/updater/src/gui/orxonox_gui_flags.cc	(revision 3286)
+++ /orxonox/branches/updater/src/gui/orxonox_gui_flags.cc	(revision 3287)
@@ -64,5 +64,5 @@
   strcat (flagText, "orxonox");
   FlagsText (widget);
-  flagsLabel->setText (flagText);
+  flagsLabel->setTitle(flagText);
 }
 
Index: /orxonox/branches/updater/src/gui/orxonox_gui_gtk.cc
===================================================================
--- /orxonox/branches/updater/src/gui/orxonox_gui_gtk.cc	(revision 3286)
+++ /orxonox/branches/updater/src/gui/orxonox_gui_gtk.cc	(revision 3287)
@@ -612,5 +612,4 @@
     }
 #endif /* HAVE_GTK2 */
-
 }
 
@@ -640,33 +639,15 @@
 }
 
-/* IMAGE */
-
-/**
-   \brief Creates a new Image
-   \param imagename the location of the Image on the Hard Disc
-*/
-Image::Image (char* imagename)
-{
-  this->init();
+/**
+   \brief Sets the Title of a Box.
+   \title the new Title to set.
+*/
+void Box::setTitle(char* title)
+{
   if (label)
     delete []label;
-  label = new char[strlen(imagename)+1];
-  strcpy(label, imagename);
-
-#ifdef HAVE_GTK2
-  widget = gtk_image_new_from_file (imagename);
-#endif /* HAVE_GTK2 */
-}
-
-/** 
-    \brief Initializes a new Image
-*/
-void Image::init()
-{
-  isOption = 0;
-
-  static_cast<Widget*>(this)->init();
-}
-
+  label = new char[strlen(title)+1];
+  strcpy(label, title);
+}
 
 /* OPTION */
@@ -1108,5 +1089,5 @@
 {
   this->init();
-  this->setText(text);
+  this->setTitle(text);
 }
 
@@ -1130,5 +1111,5 @@
    \param text The text to be inserted into the Label.
 */
-void Label::setText (char* text)
+void Label::setTitle(char* text)
 {
   if (label)
@@ -1165,5 +1146,5 @@
 {
   this->init();
-  //  this->setLabel (label);
+  this->setTitle (label);
 }
 
@@ -1192,4 +1173,16 @@
 
 /**
+   \brief Sets a ned Title to the ProgressBar.
+   \param title The now title of the ProgressBar.
+*/
+void ProgressBar::setTitle(char* title)
+{
+  if (label)
+    delete []label;
+  label = new char [strlen(title)+1];
+  strcpy(label, title);
+}
+
+/**
    \brief Sets the Total size of the Bar. (ex. The maximum one can download)
 */
@@ -1213,5 +1206,4 @@
 #endif /* HAVE_GTK2 */
   PRINTF(3)("Progress: %f\n", progress*100.0/totalSize);
-
 }
 
@@ -1223,2 +1215,43 @@
   return this->progress;
 }
+
+/* IMAGE */
+
+/**
+   \brief Creates a new Image
+   \param imagename the location of the Image on the Hard Disc
+*/
+Image::Image (char* imagename)
+{
+  this->init();
+  if (label)
+    delete []label;
+  label = new char[strlen(imagename)+1];
+  strcpy(label, imagename);
+
+#ifdef HAVE_GTK2
+  widget = gtk_image_new_from_file (imagename);
+#endif /* HAVE_GTK2 */
+}
+
+/** 
+    \brief Initializes a new Image
+*/
+void Image::init()
+{
+  isOption = 0;
+
+  static_cast<Widget*>(this)->init();
+}
+
+/**
+   \brief Sets a ned Title to the Image.
+   \param title The now title of the OptionLabel.
+*/
+void Image::setTitle(char* title)
+{
+  if (label)
+    delete []label;
+  label = new char [strlen(title)+1];
+  strcpy(label, title);
+}
Index: /orxonox/branches/updater/src/gui/orxonox_gui_gtk.h
===================================================================
--- /orxonox/branches/updater/src/gui/orxonox_gui_gtk.h	(revision 3286)
+++ /orxonox/branches/updater/src/gui/orxonox_gui_gtk.h	(revision 3287)
@@ -3,5 +3,4 @@
  \brief Contains all th different Widgets.
 */
-
 #ifndef _ORXONOX_GUI_GTK_H
 #define _ORXONOX_GUI_GTK_H
@@ -35,5 +34,5 @@
 
 #ifdef HAVE_GTK2
-bool initGTK(int argc, char *argv[]);
+bool initGTK(int argc, char* argv[]);
 bool mainloopGTK(void);
 #endif /* HAVE_GTK2 */
@@ -59,8 +58,8 @@
   char* label; //!< The name of the Widget. Some do display it, Options need it to save;
 #ifdef HAVE_GTK2
-  gulong connectSignal (char* event, gint (*signal)(GtkWidget*, GdkEvent*, void *));
-  gulong connectSignal (char* event, gint (*signal)(GtkWidget*, Widget *));
-  gulong connectSignal (char* event, void* extObj, gint (*signal)(GtkWidget*, GdkEvent*, void *));
-  gulong connectSignal (char* event, void* extObj, gint (*signal)(GtkWidget*, GdkEventKey*, void *));
+  gulong connectSignal (char* event, gint (*signal)(GtkWidget*, GdkEvent*, void* ));
+  gulong connectSignal (char* event, gint (*signal)(GtkWidget*, Widget* ));
+  gulong connectSignal (char* event, void* extObj, gint (*signal)(GtkWidget*, GdkEvent*, void* ));
+  gulong connectSignal (char* event, void* extObj, gint (*signal)(GtkWidget*, GdkEventKey*, void* ));
   void disconnectSignal (gulong signalID);
 #endif /* HAVE_GTK2 */
@@ -68,4 +67,5 @@
   void hide ();
   void setSize(int width, int height);
+  virtual void setTitle(char* title) = 0;
 
   void walkThrough (void (*function)(Widget*));
@@ -74,5 +74,5 @@
   
 #ifdef HAVE_GTK2
-  static gint doNothingSignal (GtkWidget *widget, GdkEvent* event, void* nothing);
+  static gint doNothingSignal (GtkWidget* widget, GdkEvent* event, void* nothing);
 #endif /* HAVE_GTK2 */
 };
@@ -88,4 +88,6 @@
   void setGroupName (char* name);
   char* getGroupName (void);
+
+  virtual void fill (Widget* lowerWidget) = 0;
 };
 
@@ -106,5 +108,5 @@
   //  void setBorderWidth (int borderwidth);
   //  virtual void setTitle (char* title) = 0;
-  void fill (Widget *lowerWidget);
+  void fill (Widget* lowerWidget);
 };
 
@@ -122,17 +124,17 @@
   static void addWindow(Window* windowToAdd);
 
-  Window (void);
-  Window (char* windowName);
-  void init ();
-  
-  void setTitle (char* title);
-  void showall ();
-  void open();
-  void close();
-
-#ifdef HAVE_GTK2
-  static gint windowOpen (GtkWidget *widget, GdkEvent* event, void* window);
-  static gint windowClose (GtkWidget *widget, GdkEvent* event, void* window);
-  static gint orxonox_gui_quit (GtkWidget *widget, GdkEvent *event, gpointer data);
+  Window(void);
+  Window(char* windowName);
+  void init();
+  
+  void setTitle(char* title);
+  void showall(void);
+  void open(void);
+  void close(void);
+
+#ifdef HAVE_GTK2
+  static gint windowOpen(GtkWidget* widget, GdkEvent* event, void* window);
+  static gint windowClose(GtkWidget* widget, GdkEvent* event, void* window);
+  static gint orxonox_gui_quit(GtkWidget* widget, GdkEvent* event, gpointer data);
 #endif /* HAVE_GTK2 */
 };
@@ -150,5 +152,5 @@
   void init(void);
   
-  void setTitle (char* title);
+  void setTitle(char* title);
 };
 
@@ -164,5 +166,5 @@
   void init(void);
   
-  void setTitle (char* title);
+  void setTitle(char* title);
 };
 
@@ -179,19 +181,8 @@
   Box (char boxtype);
   void init(char boxtype);
-
+  
   void fill (Widget* lowerWidget);
 
-};
-
-//! Image is the keeper of one Image 
-/** 
- * Images are mighty cool.
- * Images can help you lighten up the Programming process, and will give everyone a better impression of the Software.
- */
-class Image : public Widget
-{
- public:
-  Image (char* imgaename);
-  void init(void);
+  void setTitle(char* title);
 };
 
@@ -203,5 +194,5 @@
 {
  public:
-  //virtual gint OptionChange (GtkWidget *widget, GdkEvent *event, gpointer data);
+  //virtual gint OptionChange (GtkWidget* widget, GdkEvent* event, gpointer data);
   void init(void);
 
@@ -314,5 +305,5 @@
   void init(void);
   
-  void setText (char* text);
+  void setTitle(char* text);
   char* getText ();
 };
@@ -326,5 +317,7 @@
   ~ProgressBar ();
   void init (void);
-  
+
+  void setTitle(char* title);
+
   void setProgress (double progress);
   void setTotalSize (double totalSize);
@@ -339,5 +332,19 @@
 };
 
-//gint orxonox_gui_quit (GtkWidget *widget, GdkEvent *event, gpointer data);
+//! Image is the keeper of one Image 
+/** 
+ * Images are mighty cool.
+ * Images can help you lighten up the Programming process, and will give everyone a better impression of the Software.
+ */
+class Image : public Widget
+{
+ public:
+  Image (char* imgaename);
+  void init(void);
+
+  void setTitle(char* title);
+};
+
+//gint orxonox_gui_quit (GtkWidget* widget, GdkEvent* event, gpointer data);
 
 #endif /* _ORXONOX_GUI_GTK_H */