Index: /orxonox/branches/updater/src/gui/orxonox_gui_exec.cc
===================================================================
--- /orxonox/branches/updater/src/gui/orxonox_gui_exec.cc	(revision 3289)
+++ /orxonox/branches/updater/src/gui/orxonox_gui_exec.cc	(revision 3290)
@@ -154,5 +154,5 @@
     } 
   //  if (widget->isOption == 0)
-  //    printf ("%s\n",widget->label);
+  //    printf ("%s\n",widget->title);
   if (widget->isOption >= 1)
     if  (static_cast<Option*>(widget)->isSaveable())
@@ -160,5 +160,5 @@
 	char Buffer[256];
 	char* space2under;
-	strcpy (Buffer, static_cast<Option*>(widget)->label);
+	strcpy (Buffer, static_cast<Option*>(widget)->title);
 	if (strchr (Buffer, '_'))
 	  cout << "Warning Optionname" << Buffer << " is not Valid for Saving, because it includes an underscore" << endl;
@@ -231,10 +231,10 @@
   if (widget->isOption >= 1 && widget->isOption <= 3)
     {
-      if (!strcmp (static_cast<Option*>(widget)->label, variableName))
+      if (!strcmp (static_cast<Option*>(widget)->title, variableName))
 	static_cast<Option*>(widget)->value = atoi(variableValue);
     }
   else if (widget->isOption == 5)
     {
-       if (!strcmp (static_cast<Option*>(widget)->label, variableName))
+       if (!strcmp (static_cast<Option*>(widget)->title, variableName))
 	static_cast<OptionLabel*>(widget)->setValue(variableValue);
     }
Index: /orxonox/branches/updater/src/gui/orxonox_gui_gtk.cc
===================================================================
--- /orxonox/branches/updater/src/gui/orxonox_gui_gtk.cc	(revision 3289)
+++ /orxonox/branches/updater/src/gui/orxonox_gui_gtk.cc	(revision 3290)
@@ -91,5 +91,5 @@
 {
   next = NULL;
-  label = NULL;
+  this->title = NULL;
   return;
 }
@@ -100,7 +100,7 @@
 void Widget::destroy(void)
 {
-  if (label)
+  if (this->title)
     {
-      delete []label;
+      delete []this->title;
     }
   
@@ -175,7 +175,7 @@
     cout << "[" << static_cast<Packer*>(widget)->groupName << "]\n";
   if (widget->isOption >= 1 && widget->isOption <= 3)
-    cout << "  " << static_cast<Option*>(widget)->label <<" is : " << static_cast<Option*>(widget)->value <<endl;
+    cout << "  " << static_cast<Option*>(widget)->title <<" is : " << static_cast<Option*>(widget)->value <<endl;
   else if (widget->isOption == 5)
-    cout << "  " << static_cast<Option*>(widget)->label <<" is : " << static_cast<OptionLabel*>(widget)->cValue <<endl;
+    cout << "  " << static_cast<Option*>(widget)->title <<" is : " << static_cast<OptionLabel*>(widget)->cValue <<endl;
 }
 
@@ -425,6 +425,6 @@
 void Window::destroy(void)
 { 
-  if (label)
-    PRINTF(3)("deleting the Window: %s\n", label);
+  if (this->title)
+    PRINTF(3)("deleting the Window: %s\n", this->title);
   else 
     PRINTF(3)("deleting the Window.\n");
@@ -462,8 +462,8 @@
 void Window::setTitle (char* title)
 {
-  if (label)
-    delete []label;
-  label = new char[strlen(title)+1];
-  strcpy(label, title);
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
 #ifdef HAVE_GTK2
   gtk_window_set_title (GTK_WINDOW (widget), title);
@@ -589,6 +589,6 @@
 void Frame::destroy(void)
 { 
-  if (label)
-    PRINTF(3)("deleting the Frame: %s\n", label);
+  if (this->title)
+    PRINTF(3)("deleting the Frame: %s\n", this->title);
   else 
     PRINTF(3)("deleting the Frame.\n");
@@ -603,8 +603,8 @@
 void Frame::setTitle (char* title)
 {
-  if (label)
-    delete []label;
-  label = new char[strlen(title)+1];
-  strcpy(label, title);
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
 #ifdef HAVE_GTK2
   gtk_frame_set_label (GTK_FRAME (widget), title);
@@ -661,6 +661,6 @@
 void EventBox::destroy(void)
 { 
-  if (label)
-    PRINTF(3)("deleting the EventBox: %s\n", label);
+  if (this->title)
+    PRINTF(3)("deleting the EventBox: %s\n", this->title);
   else 
     PRINTF(3)("deleting the EventBox.\n");
@@ -675,8 +675,8 @@
 void EventBox::setTitle (char* title)
 {
-  if (label)
-    delete []label;
-  label = new char[strlen(title)+1];
-  strcpy(label, title);
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
 }
 
@@ -734,6 +734,6 @@
 void Box::destroy(void)
 { 
-  if (label)
-    PRINTF(3)("deleting the Box: %s\n", label);
+  if (this->title)
+    PRINTF(3)("deleting the Box: %s\n", this->title);
   else 
     PRINTF(3)("deleting the Box.\n");
@@ -773,8 +773,8 @@
 void Box::setTitle(char* title)
 {
-  if (label)
-    delete []label;
-  label = new char[strlen(title)+1];
-  strcpy(label, title);
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
 }
 
@@ -826,5 +826,5 @@
   defaultValue = defaultvalue;
 
-  //  cout << "Set Flagname of " << label << " to " << flagname << endl;
+  //  cout << "Set Flagname of " << this->title << " to " << flagname << endl;
 }
 
@@ -847,5 +847,5 @@
   strcpy(flagNameShort, flagnameshort);
   defaultValue = defaultvalue;
-  //  cout << "Set Flagname of " << label << " to " << flagname << endl;
+  //  cout << "Set Flagname of " << this->title << " to " << flagname << endl;
 }
 
@@ -914,6 +914,6 @@
 void Button::destroy(void)
 { 
-  if (label)
-    PRINTF(3)("deleting the Label: %s\n", label);
+  if (this->title)
+    PRINTF(3)("deleting the Label: %s\n", this->title);
   else 
     PRINTF(3)("deleting the Label.\n");
@@ -928,8 +928,8 @@
 void Button::setTitle (char *title)
 {
-  if (label)
-    delete []label;
-  label = new char[strlen(title)+1];
-  strcpy(label, title);
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
 #ifdef HAVE_GTK2
   gtk_button_set_label (GTK_BUTTON(widget), title);
@@ -988,6 +988,6 @@
 void CheckButton::destroy(void)
 { 
-  if (label)
-    PRINTF(3)("deleting the CheckButton: %s\n", label);
+  if (this->title)
+    PRINTF(3)("deleting the CheckButton: %s\n", this->title);
   else 
     PRINTF(3)("deleting the CheckButton.\n");
@@ -1002,8 +1002,8 @@
 void CheckButton::setTitle(char* title)
 {
-  if (label)
-    delete []label;
-  label = new char[strlen(title)+1];
-  strcpy(label, title);
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
 #ifdef HAVE_GTK2
   gtk_button_set_label(GTK_BUTTON(widget), title);
@@ -1028,5 +1028,5 @@
   static_cast<CheckButton*>(checkbutton)->value = (int)gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON ((CheckButton*)checkbutton->widget));
   flags->setTextFromFlags(orxonoxGUI);   ////// must be different!!!
-  cout << static_cast<CheckButton*>(checkbutton)->label << " set to: " << static_cast<CheckButton*>(checkbutton)->value << endl;
+  cout << static_cast<CheckButton*>(checkbutton)->title << " set to: " << static_cast<CheckButton*>(checkbutton)->value << endl;
 }
 #endif /* HAVE_GTK2 */
@@ -1089,6 +1089,6 @@
 void Slider::destroy(void)
 { 
-  if (label)
-    PRINTF(3)("deleting the Slider: %s\n", label);
+  if (this->title)
+    PRINTF(3)("deleting the Slider: %s\n", this->title);
   else 
     PRINTF(3)("deleting the Slider.\n");
@@ -1104,8 +1104,8 @@
 void Slider::setTitle(char* title)
 {
-  if (label)
-    delete []label;
-  label = new char[strlen(title)+1];
-  strcpy(label, title);
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
 }
 
@@ -1140,5 +1140,5 @@
   static_cast<Slider*>(slider)->value = (int)gtk_range_get_value (GTK_RANGE ((Slider*)slider->widget));
   flags->setTextFromFlags(orxonoxGUI);  //// must be different !!!
-  cout << static_cast<Slider*>(slider)->label << " set to: "<< static_cast<Slider*>(slider)->value << endl;
+  cout << static_cast<Slider*>(slider)->title << " set to: "<< static_cast<Slider*>(slider)->value << endl;
 }
 #endif /* HAVE_GTK2 */
@@ -1204,6 +1204,6 @@
 void Menu::destroy(void)
 { 
-  if (label)
-    PRINTF(3)("deleting the Menu: %s\n", label);
+  if (this->title)
+    PRINTF(3)("deleting the Menu: %s\n", this->title);
   else 
     PRINTF(3)("deleting the Menu.\n");
@@ -1220,8 +1220,8 @@
 void Menu::setTitle(char* title)
 {
-  if (label)
-    delete []label;
-  label = new char[strlen(title)+1];
-  strcpy(label, title);
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(title)+1];
+  strcpy(this->title, title);
 }
 
@@ -1259,5 +1259,5 @@
   static_cast<Menu*>(menu)->value = (int)gtk_option_menu_get_history (GTK_OPTION_MENU (menu->widget));
   flags->setTextFromFlags(orxonoxGUI); //// must be different !!!
-  cout << static_cast<Menu*>(menu)->label << " changed to : " << static_cast<Menu*>(menu)->value << endl;
+  cout << static_cast<Menu*>(menu)->title << " changed to : " << static_cast<Menu*>(menu)->value << endl;
 }
 #endif /* HAVE_GTK2 */
@@ -1304,6 +1304,6 @@
 void OptionLabel::destroy(void)
 { 
-  if (label)
-    PRINTF(3)("deleting the OptionLabel: %s\n", label);
+  if (this->title)
+    PRINTF(3)("deleting the OptionLabel: %s\n", this->title);
   else 
     PRINTF(3)("deleting the OptionLabel.\n");
@@ -1336,8 +1336,8 @@
 void OptionLabel::setTitle(char* title)
 {
-  if (label)
-    delete []label;
-  label = new char [strlen(title)+1];
-  strcpy(label, title);
+  if (this->title)
+    delete []this->title;
+  this->title = new char [strlen(title)+1];
+  strcpy(this->title, title);
 #ifdef HAVE_GTK2
   gtk_label_set_text (GTK_LABEL (widget), title);
@@ -1400,6 +1400,6 @@
 void Label::destroy(void)
 { 
-  if (label)
-    PRINTF(3)("deleting the Label: %s\n", label);
+  if (this->title)
+    PRINTF(3)("deleting the Label: %s\n", this->title);
   else 
     PRINTF(3)("deleting the Label.\n");
@@ -1414,8 +1414,8 @@
 void Label::setTitle(char* text)
 {
-  if (label)
-    delete []label;
-  label = new char[strlen(text)+1];
-  strcpy(label, text);
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(text)+1];
+  strcpy(this->title, text);
 #ifdef HAVE_GTK2
   gtk_label_set_text (GTK_LABEL (this->widget), text);
@@ -1429,5 +1429,5 @@
 char* Label::getText ()
 {
-  return label;
+  return this->title;
 }
 
@@ -1479,6 +1479,6 @@
 void ProgressBar::destroy(void)
 { 
-  if (label)
-    PRINTF(3)("deleting the ProgressBar: %s\n", label);
+  if (this->title)
+    PRINTF(3)("deleting the ProgressBar: %s\n", this->title);
   else 
     PRINTF(3)("deleting the ProgressBar.\n");
@@ -1493,8 +1493,8 @@
 void ProgressBar::setTitle(char* title)
 {
-  if (label)
-    delete []label;
-  label = new char [strlen(title)+1];
-  strcpy(label, title);
+  if (this->title)
+    delete []this->title;
+  this->title = new char [strlen(title)+1];
+  strcpy(this->title, title);
 }
 
@@ -1540,8 +1540,8 @@
 {
   this->init();
-  if (label)
-    delete []label;
-  label = new char[strlen(imagename)+1];
-  strcpy(label, imagename);
+  if (this->title)
+    delete []this->title;
+  this->title = new char[strlen(imagename)+1];
+  strcpy(this->title, imagename);
 
 #ifdef HAVE_GTK2
@@ -1573,6 +1573,6 @@
 void Image::destroy(void)
 { 
-  if (label)
-    PRINTF(3)("deleting the Image: %s\n", label);
+  if (this->title)
+    PRINTF(3)("deleting the Image: %s\n", this->title);
   else 
     PRINTF(3)("deleting the Image.\n");
@@ -1587,7 +1587,7 @@
 void Image::setTitle(char* title)
 {
-  if (label)
-    delete []label;
-  label = new char [strlen(title)+1];
-  strcpy(label, title);
-}
+  if (this->title)
+    delete []this->title;
+  this->title = new char [strlen(title)+1];
+  strcpy(this->title, title);
+}
Index: /orxonox/branches/updater/src/gui/orxonox_gui_gtk.h
===================================================================
--- /orxonox/branches/updater/src/gui/orxonox_gui_gtk.h	(revision 3289)
+++ /orxonox/branches/updater/src/gui/orxonox_gui_gtk.h	(revision 3290)
@@ -78,5 +78,5 @@
   //! defines isOption states
   enum option { containerType = -2, boxType = -1, nothingType = 0, boolType = 1, intType = 2}; 
-  char* label;                      //!< The name of the Widget. Some do display it, Options need it to save;
+  char* title;                      //!< The name of the Widget. Some do display it, Options need it to save;
 };
 